//: C10:SbernyParametrDemo.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
#include <iostream>
#include <string>
#include <vector>
using namespace std;

class SbernyParametr : public vector<string> {};

class Plnicka {
public:
  void f(SbernyParametr& cp) {
    cp.push_back("accumulating");
  }
  void g(SbernyParametr& cp) {
    cp.push_back("items");
  }
  void h(SbernyParametr& cp) {
    cp.push_back("as we go");
  }
};

int main() {
  Plnicka plnicka;
  SbernyParametr cp;
  plnicka.f(cp);
  plnicka.g(cp);
  plnicka.h(cp);
  vector<string>::iterator it = cp.begin();
  while(it != cp.end())
    cout << *it++ << " ";
  cout << endl;
} ///:~
